import logging,os,json,time,requests
from abstract_utilities import make_list
def tally_profits(txn_history):
    """
    Organize and calculate transaction data for each user.

    Parameters:
        txn_history (list of dict): The transaction history data.

    Returns:
        dict: Organized data for each user.
    """
    input(txn_history)
    txnData_js = {}
    for txn in txn_history:
        user = txn['user_address']
        if isinstance(txn,list):
            txn = txn[0]
        txns=txn
        for tcn in txn['tcns']:
            txns = {**txns,**tcn}
        txn = txns
        print(txn)
#        txn = {**txn,**{tcn for tcn in make_list(txn['tcns']) if tcn}}
        if user not in txnData_js:
            txnData_js[user] = {
                "profits": {"sol": 0, "token": 0},
                "avgPrice": {'tokenamount': 0, 'sol': 0, "avg": 0},
                "volume": {"sell": 0, "buy": 0, "total": 0},
                "txns": []
            }
        # Calculate price
        txn['price'] = get_price(txn.get('virtualsolreserves'), txn.get('virtualtokenreserves'))
        solAmt = float(txn['sol_amount'])
        tknAmt = float(txn['token_amount'])
        txnData_js[user]["volume"]["total"] += solAmt

        if txn.get('isbuy'):
            txnData_js[user]["volume"]["buy"] += solAmt
            txnData_js[user]["profits"]["sol"] -= solAmt
        else:
            txnData_js[user]["volume"]["sell"] += solAmt
            txnData_js[user]["profits"]["sol"] += solAmt

        txnData_js[user]["avgPrice"]['tokenamount'] += tknAmt
        txnData_js[user]["avgPrice"]['sol'] += solAmt
        txnData_js[user]["avgPrice"]["avg"] = (
            (txnData_js[user]["avgPrice"]['sol'] or 1) /
            (txnData_js[user]["avgPrice"]['tokenamount'] or 1)
        )
        txnData_js[user]["txns"].append(txn['signature'])

    return txnData_js
